package routes

// |@@| C

import (
	"gardening/src/dat/maes"
	"gardening/src/lib/logger"
	"gardening/src/lib/maestro"
	"gardening/src/lib/route"
	"gardening/src/mae"
	"gardening/src/srv/html_views"
	"gardening/src/srv/urlers"
	"github.com/gin-gonic/gin"
	"gitlab.com/ccyrillee/kitcla/goc"
)

type ShowUserAppRoute struct {
	AppRoute     *route.AppRoute
	AppUrler     *urlers.AppUrler
	Logger       *logger.Logger
	ShowUserMae  *mae.ShowUserMae
	ShowUserView *html_views.ShowUserView
}

func (this *ShowUserAppRoute) Act(c *gin.Context) (maestro.MaeIn, maestro.MaeOut) {
	in := &maes.ShowUserMaeIn{}
	this.AppRoute.PopulateInContext(c, &in.Context)
	in.Request.Id = this.AppRoute.GetId(c)
	out, errMae := this.ShowUserMae.Act(c, in)
	if errMae != nil {
		panic(errMae)
	}
	this.AppRoute.RenderView(c, func() goc.HTML {
		return this.ShowUserView.H(out)
	}, &out.Extra)
	this.Logger.LogRoute(c)
	return in, out
}
func (this *ShowUserAppRoute) GetRoutePath() string {
	return "show-user"
}
func (this *ShowUserAppRoute) GetMethod() string {
	return "GET"
}
